#include "dx_dev.h"
#include <tchar.h>

bool UtilDoMessageLoop();

bool CDXDevice::Create(HWND hWnd,int Width,int Height)
{
	if(CDXDevice::IsOK()){
		//DXTRACE_ERR(_T(__FUNCTION__)_T("():Direct3D ͊ɏĂ܂"),E_FAIL);
		return false;
	}

	m_hWnd=hWnd;

	// Direct3D IuWFNg쐬
	if(NULL == (m_lpD3D = Direct3DCreate9(D3D_SDK_VERSION))){
		//DXTRACE_ERR(_T(__FUNCTION__)_T("():Direct3D ̍쐬Ɏs܂"),E_FAIL);
		return false;
	}

	// fXNgbv̉ʃ[h擾
	HRESULT hr;
	D3DDISPLAYMODE modeDesktop;
	hr=m_lpD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&modeDesktop);
	if(FAILED(hr)){
		//DXTRACE_ERR(_T(__FUNCTION__)_T("():ʃ[h擾ł܂\n"),hr);
		return false;
	}

	// Direct3D p[^̐ݒ
	ZeroMemory(&m_D3DParam,sizeof(m_D3DParam));
	m_D3DParam.MultiSampleType = D3DMULTISAMPLE_NONE;
	m_D3DParam.SwapEffect = D3DSWAPEFFECT_DISCARD;
	m_D3DParam.hDeviceWindow = hWnd;
	m_D3DParam.BackBufferCount = 1;
	m_D3DParam.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	m_D3DParam.EnableAutoDepthStencil = FALSE;

	DWORD dwFlg=D3DCREATE_MIXED_VERTEXPROCESSING|D3DCREATE_FPU_PRESERVE;

	m_D3DParam.Windowed = TRUE;

	// fXNgbv̉ʃ[hݒ
	m_D3DParam.BackBufferFormat = modeDesktop.Format;

	// REF ō쐬
	if(SUCCEEDED(m_lpD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF,hWnd,dwFlg,&m_D3DParam,&m_lpD3DDevice))){
		return true;
	}

	return false;
}

CDXDevice::~CDXDevice()
{
	Destroy();
}


void CDXDevice::Destroy()
{
	RELEASE(m_lpD3DDevice);
	RELEASE(m_lpD3D);
}

bool CDXDevice::Reset()
{
	if(!CDXDevice::IsOK()){
		return false;
	}
	HRESULT hr=m_lpD3DDevice->Reset(&m_D3DParam);
	if(hr==D3DERR_DRIVERINTERNALERROR){
		throw "D3DERR_DRIVERINTERNALERROR";
	}
	if(FAILED(hr)){
		return false;
	}

	return true;
}

bool CDXDevice::ResetDeviceIfLost()
{
	if(!CDXDevice::IsOK()){
		return false;
	}

	//foCXԂmF
	HRESULT hr=m_lpD3DDevice->TestCooperativeLevel();
	switch(hr){
	case D3DERR_DEVICENOTRESET:	//XgăZbg\
		return Reset();	//Zbg
	case D3DERR_DEVICELOST:		//XgăZbg͂܂łȂ
		for(;;){
			if(!UtilDoMessageLoop())break;
		}
		Sleep(0);
		return false;
	case D3DERR_DRIVERINTERNALERROR:
		return Reset();	//Zbg݂
	default:	//
		return true;
	}
}
